// Rover R20 mail2code
// Build instruction on:
// https://homofaciens.de/technics-robots-R20-construction_en.htm

$fn=100;

//Raspberry Pi mount point
raspi_m_l = 58;
raspi_m_w = 49;
raspi_m_shift_x = -15;
raspi_m_shift_y = 0;
raspi_m_d = 5;
raspi_m_screw_d = 2;
raspi_m_h = 6;
raspi_m_socket = 1;

//Stepper motor dimensions
sm_d = 28;
sm_h = 19;
sms_d = 5;
sms_h = 8;     //shaft height
sms_shift = 8;  //shaft shift from center
smb_w = 15;   //buckle width
smb_h = 4.5;     //buckle height
sm_mount_dis = 35;  //mount points distance
sm_mount_d = 4;     //mount points diameter

chassis_w = 105.5;
chassis_l = 180;
chassis_h = 45;
chassis_wall = 4;

servo_w = 21;
servo_l = 41;
servo_lt = 53;
servo_h1 = 26.67;
servo_h2 = 9.35;
servo_h = servo_h1 + servo_h2;
servo_m_d = 10.15;
servo_m_l = (servo_lt-servo_l)/2;

servo_cut_w = 41;
servo_cut_h = 21;
servo_mount_x = 50/2;
servo_mount_d = 10;
servo_mount_d2 = 48.76;
servo_axis_offset = 9.66;

front_axis_x = chassis_l/2-25-12.5;
front_axis_y = 27;
rear_axis_x = -chassis_l/2+22+12.5;
rear_axis_y = front_axis_y;

//Chassis mount holes grid parameters
ch_dis_x = 10;
ch_dis_y = 10;
ch_no_x = 9;
ch_no_y = 16;
ch_no_x2 = 9;
ch_no_y2 = 3;
ch_l = 4;
ch_w = 3.2;
ch_w2 = 5;

rear_axle_d = 4.5;


track_l = 37.5;
track_h = 16;
track_w = 25;
track_wall = 2.5;
track_tolerance_w = 0.6;
tow = 8; //Tracks On Wheel

M3_hole = 3.4;
M3_nut_e = 6.4;
M4_hole = 4.4;


/*
// Chain test
for(i=[0:45:315]){
  rotate([0, 0, i]){
    translate([47, 0, 0]){
      cable_chain();
    }
  }
}
rotate([0, 0, 22.5]){
  for(i=[0:90:270]){
    rotate([0, 0, i]){
      translate([25, 0, 0]){
        cable_chain();
      }
    }
  }
}
rotate([0, 0, 11.25]){
  cable_chain();
}
*/


/*
// Multiple chains in rows
cr_no_x = 2;
cr_no_y = 4;
cr_w = 37;
cr_l = 36;
for(i=[0:1:cr_no_x-1]){
  for(j=[0:1:cr_no_y-1]){
    translate([cr_w*i, cr_l*j, 0]){
      cable_chain(1);
    }
  }
}
*/


//rotate([180,0,0])
//difference(){
//  cube(size=[60,30,3], center=true);
//  translate([0, 0, -19])
//  servo();
//}

Assembled = 0;

if(Assembled == 0){
//  chassis();
//  cable_chain(1);
//  cable_chain_old(1);
//  rear_wheel();
  rear_wheel_mount();
//  drive_wheel();
//  drive_wheel_round();
//  camera_mount();
//  power_pole();
//  bumper(0, 38);
//  battery_mount();
//  pi_mount();
//  arduino_mount();
//  spacer();
  
}
else{
  rotate([180, 0, 0]){
    chassis();
    translate([-75.7, front_axis_x, 13*0]){
      rotate([0, 0, 90]){
        cable_chain();
      }
    }


    for(i=[0:1:1]){
      mirror([i, 0, 0]){
        translate([-85, rear_axis_x, 33.5]){
          rotate([90, 0, 90]){
            rear_wheel();
          }
        }

        translate([0, 10, 35+track_h/2]){
          rotate([90, 0, 0]){
    //        rear_wheel_mount();
          }
        }


        translate([-85, front_axis_x, 33.5]){
          rotate([90, 360/(8*2), 90]){
            drive_wheel();
          }
        }
      }
    }

    translate([0, 135.5, -44.5]){
      rotate([0, 180, 0]){
        camera_mount();
      }
    }

    translate([0, 50, -10]){
      rotate([0, 180, 0]){
        pi_mount();
      }
    }
    translate([0, -70, -10]){
      rotate([0, 180, 180]){
        arduino_mount();
      }
    }

      
    translate([0, -117, 50]){
      rotate([180, 0, 90]){
        bumper(0, 38);
      }
    }
    translate([0, 117, 50]){
      rotate([180, 0, 270]){
        bumper(0, 38);
      }
    }

    translate([-45, 107, -35]){
      rotate([90, 90, 90]){
        servo();
      }
    }

    
  }

}

module spacer(){
  s_h = 20;
  s_d = 15;
  brim_h = 0.35;
  brim_d = 30;
  
  for(j=[0:1:1])
  translate([0, j*17, 0])
  for(i=[0:1:2])
  translate([i*17, 0, 0])
  difference(){
    union(){
      translate([0, 0, s_h/2])
      cylinder(d=s_d, h=s_h, center=true);
      translate([0, 0, brim_h/2])
      cylinder(d=brim_d, h=brim_h, center=true);
    }
    translate([0, 0, s_h/2])
    cylinder(d=M3_hole, h=s_h*1.1, center=true);
  }
}

module camera_mount(){
  cam_w = 27;
  cam_h = 25;
  cam_l = 14;
  cam_pos = -1;
  cam_slot = 1.5;
  cam_slot_w = 3;

  cm_wall = 2;
  cm_w = cam_w + 35;
  cm_h = cam_h+cm_wall;

  lever_l = 45;
  lever_radius = 5;
  lever_gap = 20;
  lever_z = lever_radius-cm_h/2;
  
  //Servo horn mount holes
  shm_l1 = lever_l - 13.7-21;

  lever2_l = -15;//
  lever2_radius = 5;
  lever2_z = lever2_radius-cm_h/2;

  LED_d = 5.1;
  LED_w = cm_w - 12;
  LED_no = 3;


  // Servo mount
  sm_l = 33;
  sm_w = 23;
  sm_h = 15;
  sm_wall = 2;
  sm_wall2 = 5;//
  translate([40, -30, sm_h/2])
  difference(){
    hull(){
      cube(size=[sm_wall2, sm_wall, sm_h], center=true);
      translate([-sm_l, 0, 0])
      cube(size=[sm_wall2, sm_wall, sm_h], center=true);
      translate([0, sm_w, 0])
      cube(size=[sm_wall2, sm_wall, sm_h], center=true);
    }
    translate([-sm_wall2, sm_wall, sm_wall])
    hull(){
      cube(size=[sm_wall, sm_wall, sm_h], center=true);
      translate([-sm_l, 0, 0])
      cube(size=[sm_wall, sm_wall, sm_h], center=true);
      translate([0, sm_w, 0])
      cube(size=[sm_wall, sm_wall, sm_h], center=true);
    }
    // Mount holes for rasperry mount
    translate([-ch_dis_x, 0, 0])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=sm_w*1.1, center=true);
    translate([-3*ch_dis_x, 0, 0])
    rotate([90, 0, 0])
    cylinder(d=M3_hole, h=sm_w*1.1, center=true);

    // Mount holes for servo
    translate([19, 13, 28])
    rotate([0, 90, 180])
    servo();
  }

  //Camera box
  difference(){
    translate([0, 0, cm_h/2])
    rotate([90, 0, 180]){
      difference(){
        roundedRect(size=[cm_w, cm_h, cm_wall], radius=3);
        gap = cm_h / LED_no;
        for(i=[0:1:LED_no-1]){
          translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
            cylinder(d=LED_d, h=cm_wall*1.1, center=true);
          }
          mirror([1, 0, 0]){
            translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
              cylinder(d=LED_d, h=cm_wall*1.1, center=true);
            }
          }
        }
      }
      hull(){
        roundedRect(size=[cam_w+2*cm_wall, cm_h, cam_l], radius=2);
        translate([cm_h/2+2, cm_h/2-5, cam_l/2])
        cylinder(d=10, h=cam_l, center=true);
        translate([-cm_h/2-2, cm_h/2-5, cam_l/2])
        cylinder(d=10, h=cam_l, center=true);
      }              
    }
    // Cut camera
    translate([0, cam_l/2+cm_wall-2, cm_h/2+cm_wall]){
      cube(size=[cam_w-2*cam_slot_w, cam_l-4, cam_h], center=true);
    }
    translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall+12.5]){
      cube(size=[15, cam_l, cam_h], center=true);
    }
    translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall]){
      rotate([90, 0, 0]){
        cylinder(d=15, h=cam_l, center=true);
      }
    }
    // Cut camera slit
    translate([0, cam_l/2+cam_pos, cm_h/2+cm_wall]){
      cube(size=[cam_w*2, cam_slot, cam_h], center=true);
    }
    translate([cm_h/2+2, 0, cm_h-5])
    rotate([90, 0, 0]){
      cylinder(d=M3_hole, h=cam_l*2.1, center=true);
      translate([0, 0, 4])
      cylinder(d=M3_nut_e, h=cam_l, center=true, $fn=6);
    }
    translate([-cm_h/2-2, 0, cm_h-5])
    rotate([90, 0, 0]){
      cylinder(d=M3_hole, h=cam_l*2.1, center=true);
      translate([0, 0, 4])
      cylinder(d=M3_nut_e, h=cam_l, center=true, $fn=6);
    }

  }
  
  
  //Lever mounts
  translate([0, 0, cm_h/2])
  rotate([0, 90, 0])
  difference(){
    hull(){
      translate([-lever_z, -lever_l, 0]){
        cylinder(r=lever_radius, h=cm_wall, center=true);  
      }
      translate([0, cm_wall/2, 0]){
        cube(size=[cm_h, cm_wall, cm_wall], center=true);
      }
    }
    hull(){
      translate([-lever_z, -lever_l, 0]){
        cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
      }          
      translate([-lever_z, -lever_l+(lever_l-shm_l1)/2-3, 0]){
        cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
      }          
    }
    hull(){
      translate([-lever_z, -shm_l1, 0]){
        cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
      }          
      translate([-lever_z, -lever_l+(lever_l-shm_l1)/2+3, 0]){
        cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
      }          
    }
  }
    
  brim_h = 0.35;
  brim_d = 10;
  translate([cm_w/2, 0, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  translate([-cm_w/2, 0, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  translate([0, -lever_l-2, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);

}


module arduino_mount(){
  am_l = 114;
  am_w = 65;
  am_wall = 2;
  am_h = 8;
  screw_d = 1.5;
  
  //arduino board dimensions
  ab_l = 101.6;
  ab_w = 53.3;
  // mount points Arduino board
  m_X1 = (66.1)-ab_l/2;
  m_Y1 = (27.9+5.1+2.5)-ab_w/2;

  m_X2 = (66.1)-ab_l/2;
  m_Y2 = (5.1+2.5)-ab_w/2;

  m_X3 = (1.3+14)-ab_l/2;
  m_Y3 = (15.2+27.9+5.1+2.5)-ab_w/2;
  
  m_X4 = (24.1+50.8+1.3+14)-ab_l/2;
  m_Y4 = (15.2+27.9+5.1+2.5)-ab_w/2;
  
  m_X5 = (82.55+14)-ab_l/2;
  m_Y5 = (2.5)-ab_w/2;

  m_X6 = (14)-ab_l/2;
  m_Y6 = (2.5)-ab_w/2;
  
  
  difference(){
    union(){
      translate([0, 0, am_h/2])
      cube(size=[am_l, am_w, am_h], center=true);


    }
    // Center cut
    difference(){
      translate([0, 0, am_h/2+am_wall])
      cube(size=[am_l-4*am_wall, am_w-4*am_wall, am_h], center=true);

      // Mount points 
      translate([m_X1, m_Y1, am_h/2])
      cylinder(d1=12, d2=4, h=am_h, center=true);

      translate([m_X2, m_Y2, am_h/2])
      cylinder(d1=12, d2=4, h=am_h, center=true);

      translate([m_X3, m_Y3, am_h/2])
      cylinder(d1=12, d2=4, h=am_h, center=true);

      translate([m_X4, m_Y4, am_h/2])
      cylinder(d1=12, d2=4, h=am_h, center=true);

      translate([m_X5, m_Y5, am_h/2])
      cylinder(d1=10, d2=4, h=am_h, center=true);

      translate([m_X6, m_Y6, am_h/2])
      cylinder(d1=12, d2=4, h=am_h, center=true);

    }
    // Arduino mount points cut
    translate([m_X1, m_Y1, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    translate([m_X2, m_Y2, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    translate([m_X3, m_Y3, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    translate([m_X4, m_Y4, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    translate([m_X5, m_Y5, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    translate([m_X6, m_Y6, am_h/2])
    cylinder(d=screw_d, h=am_h*1.1, center=true);

    // Chassis mount point cuts
    translate([2.5*ch_dis_x, 2*ch_dis_y, am_h/2])
    cylinder(d=M3_hole, h=am_h*1.1, center=true);
    translate([2.5*ch_dis_x, -2*ch_dis_y, am_h/2])
    cylinder(d=M3_hole, h=am_h*1.1, center=true);
    translate([-3.5*ch_dis_x, 0, am_h/2])
    cylinder(d=M3_hole, h=am_h*1.1, center=true);
    
    // Extra mount holes
    for(j=[0:1:1])mirror([0,j,0]){
      for(i=[-5:1:5])
      translate([i*ch_dis_x, am_w/2-am_wall, (am_wall+am_h)/2-0.5])
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=am_wall*2.1, center=true);
        translate([0, 0, 1.5/2+0.1])
        cylinder(d=M3_nut_e, h=2*am_wall-1.5, center=true, $fn=6);
      }
    }

    for(j=[0:1:1])mirror([j,0,0]){
      for(i=[-2:1:2])
      translate([am_l/2-am_wall, i*ch_dis_x, (am_wall+am_h)/2-0.5])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=am_wall*2.1, center=true);
        translate([0, 0, -(1.5/2+0.1)])
        rotate([0, 0, 30])
        cylinder(d=M3_nut_e, h=2*am_wall-1.5, center=true, $fn=6);
      }
    }
  }
}


module pi_mount(){
  //Raspberry Pi mount points
  raspi_m_l = 58;
  raspi_m_w = 49;
  raspi_m_shift_x = -10;
  raspi_m_shift_y = 0;
  raspi_m_d = 5;
  raspi_m_screw_d = 2;
  raspi_m_h = 6;
  raspi_m_socket = 1;  
  
  pm_wall = 2;
  pm_w = 78;
  pm_l = 100;
  
  wall_h = 8;
  mount_holes_x = 29;
  
  tower_m_d = 20;
  tower_m_x = -5;
  
  //Central cut
  cc_d = 20;
  cc_l = 25;
  
  //micro USB power supply cut
  psc_d = 50;
  psc_x = -30;
  psc_z = 27;

  
  translate([0, 0, pm_wall/2]){
    block_l = 4;
    block_w = 35;
    block_h = servo_w+5;
    block_edge = 8;

    
    difference(){
      union(){
        cube(size=[pm_l, pm_w, pm_wall], center=true);
        //Pi mount points
        translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall/2]){
          translate([raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=raspi_m_d*3,
                     d2=raspi_m_d,
                     h=raspi_m_h,
                     center=true);
          }
          translate([raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=raspi_m_d*3,
                     d2=raspi_m_d,
                     h=raspi_m_h,
                     center=true);
          }
          translate([-raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=raspi_m_d*3,
                     d2=raspi_m_d,
                     h=raspi_m_h,
                     center=true);
          }
          translate([-raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d1=raspi_m_d*3,
                     d2=raspi_m_d,
                     h=raspi_m_h,
                     center=true);
          }
        }
        //Walls
        translate([(pm_l-pm_wall)/2, 0, raspi_m_h/2]){
          cube(size=[pm_wall, pm_w, raspi_m_h], center=true);
        }
        translate([(pm_l-pm_wall)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 35]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([(pm_wall-pm_l)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 33]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        for(i=[0:1:1])mirror([0,i,0])
        translate([0, pm_w/2-pm_wall, wall_h/2]){
          cube(size=[pm_l, pm_wall*2, wall_h], center=true);
        }
      }
      //Mount holes on chassis
      translate([-1.5*ch_dis_y, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([-1.5*ch_dis_y, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      //Central hole
      hull(){
        translate([cc_l/2-12, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
        translate([-cc_l/2-12, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
      }
      //Mount holes power pole
      holes = 9;
      for(i=[1:1:holes]){
        translate([-pm_l/2+i*ch_dis_x, pm_w/2, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }
        translate([-pm_l/2+i*ch_dis_x, pm_w/2-pm_wall-1.5, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        if(i>3){
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
            }
          }
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2+pm_wall+1.5, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
            }
          }
        }

      }
      // Cut micro USB for power supply
      translate([psc_x, -pm_w/2, psc_z]){
        rotate([90, 0, 0]){
          cylinder(d=psc_d, h=pm_wall*4.1, center=true);
        }
      }
      
      //Pi mount holes
      translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall]){
        translate([raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
      }
      
    }
    
  }
}



module battery_mount(){
  bm_l = 100;
  bm_w = chassis_w - 2 * chassis_wall - 1;
  bm_h = 4;
  bm_wall = 2;
  grid_no_x = 9;
  grid_no_y = 9;
  hinge_h = 10;
  hinge_l = 10;
  hinge_w = 5;
  
  display_w = 43;
  display_h = 35;
  display_x = 27.5;
  
  // Battery clamp
  bc_l = 5* ch_dis_y;
  bc_h = 10;
  bc_wall = 7;
  
  translate([100, 0, 0])
  difference(){
    union(){
      roundedRect([bc_l, bm_w, bm_wall], 5);
      for(i=[0:1:1])mirror([0,i,0])
      translate([0, (bm_w-bc_wall)/2, 0])
      roundedRect([bc_l, bc_wall, bc_h], 2);    
    }
    for(j=[0:1:1])mirror([j,0,0])
    for(i=[0:1:1])mirror([0,i,0])
    translate([2*ch_dis_x, 4.5*ch_dis_y, bc_h/2]){
      cylinder(d=M3_hole, h=bc_h*1.1, center=true);
      translate([0, 0, -5])
      hull(){
        cylinder(d=M3_hole, h=bc_h, center=true);
        cylinder(d=M3_nut_e, h=bc_h-3, center=true, $fn=6);
      }
    }
  }
  
  // Hinges
  difference(){
    translate([-7.5, 0, 0])
    for(j=[0:1:1])mirror([j,0,0])
    for(i=[0:1:1])mirror([0,i,0]){
      translate([(hinge_l-bm_l)/2+7.5, bm_w/2, hinge_h/2])
      difference(){
        rotate([90, 0, 0])
        roundedRect([hinge_l, hinge_h, hinge_w], 2, [0,0,1,1]);
        translate([-2, 0, 1])
        rotate([90, 0, 0])
        cylinder(d=M3_hole, h=hinge_w*2.1, center=true);
      }
    }
    // Rear edge cut
    translate([-bm_l/2-3, 0, bm_h/2-2])
    rotate([0, 45, 0])
    cube(size=[10, bm_w*1.1, 10], center=true);
  }
  
  // Base plate
  translate([0, 0, bm_h/2])
  difference(){
    union(){
      cube(size=[bm_l, bm_w, bm_h], center=true);
    }
    // inner cut
    translate([bm_wall+2, 0, bm_wall])
    cube(size=[bm_l, bm_w-2*bm_wall, bm_h], center=true);
    // Rear edge cut
    translate([-bm_l/2-3, 0, -2])
    rotate([0, 45, 0])
    cube(size=[10, bm_w*1.1, 10], center=true);
    
    // Display cut
    translate([display_x, 0, -bm_h/2-0.1])
    roundedRect([display_h, display_w, bm_h], 5);
    
    //mount holes grid bottom
    for(j=[-grid_no_y/2:1:grid_no_y/2]){
      for(i=[1-grid_no_x/2:1:grid_no_x/2]){
        a=ch_dis_x * i - 2;
        b=ch_dis_y * j;
        translate([a, b, 2.26]){
          cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
//          translate([0, 0, chassis_wall/2-2.26+.75])
//          cylinder(d=M3_nut_e, h=chassis_wall, center=true, $fn=6);
        }
      }
    }
    
  }
  
  
}



module power_pole(){
  pp_d = 5;
  pp_h = 150;
  pp_wall = 5;
  pp_l = 10;
  pp_w = chassis_w;
  pp_flap_h = 10;
  
  difference(){
    union(){
      roundedRect([pp_w+2*pp_wall, pp_h, pp_l], 40, [1,1,0,0]);
      hull(){
        translate([(pp_w+pp_wall)/2, (pp_h-pp_flap_h)/2, 0.1]){
          cube(size=[pp_wall, pp_flap_h, 0.05], center=true);
        }
      }
      translate([0, -(pp_h/2+10), pp_l/2]){
        intersection(){
          cube(size=[pp_l*3, 20, pp_l], center=true);
          rotate([90, 0, 0]){
            cylinder(d=pp_l*2.2, h=20, center=true);
          }
        }
      }
    }
    translate([0, pp_wall, -0.1]){
      roundedRect([pp_w, pp_h, pp_l*1.1], 40, [1,1,0,0]);
    }
    //Top holes
    translate([0, -(pp_h-pp_flap_h)/2, 5]){
      rotate([90, 0, 0]){
        cylinder(d=4.5, h=pp_w+2*pp_wall*1.1, center=true);    
      }
    }
    for(i=[0:1:1]){
      mirror([i,0,0]){
        translate([7, -(pp_h-pp_flap_h)/2-10, 0]){
          cylinder(d=2, h=pp_w+2*pp_wall*1.1, center=true);        
        }
        translate([7, -(pp_h-pp_flap_h)/2-20, 0]){
          cylinder(d=2, h=pp_w+2*pp_wall*1.1, center=true);            
        }
      }
    }
    
    //Mount holes
    for(i=[0:1:5])
    translate([0, (pp_h-10)/2-i*ch_dis_y, 5])
    rotate([0, 90, 0])
    cylinder(d=M3_hole, h=pp_w*2.1, center=true);            
    
  }
  brim_h = 0.35;
  brim_d = 20;
  for(i=[0:1:1])
  mirror([i,0,0])
  translate([(pp_w+pp_wall)/2, (pp_h-10)/2+4, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);        

  
}




module bumper(cut=0, bmp_l=23){
  
  bmp_h = 20;
  bmp_s_h = 40;//Shield height
  bmp_h_shift = 10;
  bmp_w = chassis_w + 2*40;;
  bmp_r = 200;
  bmp_wall = 3;
  bmp_gap = 20;
  bmp_gap2 = bmp_gap+6;
  bmp_edge_d = 7;
  bmp_edge_x = bmp_w/2-2.7;
  bmp_edge_y = 18.0;
  
  enforcement_edge = 40;
  linkage=30;
  M3_d = 3.5;
  
  translate([0, 0, bmp_h/2]){
    translate([bmp_edge_y, bmp_edge_x, (bmp_s_h-bmp_h)/2-Assembled*(bmp_s_h-bmp_h)/2]){
      cylinder(d=bmp_edge_d, h=bmp_s_h, center=true);
    }
    translate([bmp_edge_y, -bmp_edge_x, (bmp_s_h-bmp_h)/2-Assembled*(bmp_s_h-bmp_h)/2]){
      cylinder(d=bmp_edge_d, h=bmp_s_h, center=true);
    }
    rotate([0, 0, 0]){
      difference(){
        union(){
          
          //Schield
          translate([193, 0, (bmp_s_h-bmp_h)/2-Assembled*(bmp_s_h-bmp_h)/2]){
            difference(){
              cylinder(d=bmp_r*2, h=bmp_s_h, center=true);
              translate([0, bmp_r+bmp_w/2, 0]){
                cube(size=[bmp_r*2, bmp_r*2, bmp_s_h*1.1], center=true);
              }
              translate([0, -(bmp_r+bmp_w/2), 0]){
                cube(size=[bmp_r*2, bmp_r*2, bmp_s_h*1.1], center=true);
              }
              difference(){
                translate([bmp_wall, 0, 0]){
                  cylinder(d=bmp_r*2, h=bmp_s_h*1.1, center=true);
                }
                //Mount point on shield
                difference(){
                  translate([-bmp_r-5, 0, 0]){
                    rotate([90, 0, 0]){
                      cylinder(d=bmp_s_h*1.1, h=bmp_gap, center=true);
                    }
                  }
                  translate([10-bmp_r, 0, 0]){
                    rotate([90, 0, 0]){
                      cylinder(d=M3_hole, h=bmp_gap*1.1, center=true);
                    }
                  }
                }
              }
            }
          }
          //Front connectors
          difference(){
            union(){
              translate([bmp_l/2, (bmp_gap2+bmp_wall)/2, 0]){
                cube(size=[bmp_l+bmp_wall, bmp_wall, bmp_h], center=true);
              }
              translate([bmp_l/2, -(bmp_gap2+bmp_wall)/2, 0]){
                cube(size=[bmp_l+bmp_wall, bmp_wall, bmp_h], center=true);
              }
            }
            hull(){
              translate([4, 0, 0]){
                rotate([90, 0, 0]){
                  cylinder(d=M3_hole, h=bmp_gap*2, center=true);
                }
              }
              translate([-0.6, 0, 0]){
                cube(size=[0.2, bmp_gap*2, M3_hole], center=true);
              }
            }
            
          }
          //rear wall with mount holes
          translate([bmp_l, 0, bmp_h_shift/2]){
            difference(){
              cube(size=[bmp_wall, bmp_gap2+2*bmp_wall, bmp_h+bmp_h_shift], center=true);
              hull(){
                translate([0, ch_dis_x/2, 5+bmp_h_shift/2]){
                  rotate([0, 90, 0]){
                    cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  }
                }
                translate([0, ch_dis_x/2, bmp_h_shift/2-5]){
                  rotate([0, 90, 0]){
                    cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  }
                }
              }
              hull(){
                translate([0, -ch_dis_x/2, 5+bmp_h_shift/2]){
                  rotate([0, 90, 0]){
                    cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  }
                }
                translate([0, -ch_dis_x/2, bmp_h_shift/2-5]){
                  rotate([0, 90, 0]){
                    cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  }
                }
              }
            }


          }
        }
      }
    }
  }



  
  
}
  

module drive_wheel(){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;
  
  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));
  
  radius = (chain_l/2)/sin(180/tow)+track_h/2;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_d = 20;
  hub_h = wheel_w+5;
  hub_hole = 3.5;
  hub_hole_2 = 10;
  hub_hole_3 = 5.5;
  servo_hub_h = 4;
  servo_hub_h2 = 3;
  
  translate([0, 0, wheel_w/2]){
    difference(){
      intersection(){
        edge1=7;
        edge2=5;
        wx1=0;
        wy1=wheel_w/2;
        wx2=radius-edge1;
        wy2=wheel_w/2;
        wx3=radius;
        wy3=wheel_w/2-edge2;
        wx4=wx3;
        wy4=-wy3;
        wx5=wx2;
        wy5=-wy2;
        wx6=0;
        wy6=-wy1;
        rotate_extrude($fn=tow){
          polygon(points=[[wx1,wy1],[wx2,wy2],[wx3,wy3],[wx4,wy4],[wx5,wy5],[wx6,wy6]]);
        }
        // Cut tips of teeth
        cylinder(r=radius-2.5, h=wheel_w, center=true);
      }
      
      //cylinder($fn=tow, r=radius, h=wheel_w, center=true);
      x1=0;
      y1=horn_w1/2;
      x2=horn_d/2-horn_w2/2;
      y2=horn_w2/2;
      x3=horn_d/2-horn_w2/2;
      y3=-horn_w2/2;
      x4=0;
      y4=-horn_w1/2;
      
      translate([0, 0, wheel_w/2-horn_thickness/2+0.1]){
        cylinder(d=15, h=horn_thickness, center=true);
      }
      for(i=[0:90:360]){
        rotate([0, 0, i]){
          translate([horn_mount, 0, 0]){
            cylinder(d=3, h=wheel_w*1.1, center=true);
          }
          translate([(horn_d-horn_w2)/2, 0, wheel_w/2-horn_thickness/2+0.1]){
            cylinder(d=horn_w2, h=horn_thickness, center=true);
          }
          translate([0, 0, wheel_w/2-horn_thickness+0.1]){
            linear_extrude(height=horn_thickness){
              polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
            }
          }
        }
      }
      for(i=[0:1:tow-1]){
        rotate([0, 0, 180/tow + 360/tow*i]){
          translate([radius*cos(180/tow)+0.1, 0, 0]){
            rotate([90, 0, 270]){
              linear_extrude(height=track_wall+0.1, scale=0.8){
                square(size=[15.5, hub_h*2], center=true);
              }
            }
          }
        }
      }
      cylinder(d=hub_hole, h=hub_h*1.5, center=true);
      cylinder(d=hub_hole_2, h=hub_h, center=true);
      
      // Spikes mount holes
      for(i=[0:360/tow/2:360-360/tow/2]){
        rotate([0, 0, i]){
          for(j=[0:1:1])mirror([0, 0, j]){
            translate([radius, 0, 3])
            rotate([0, 90, 0])
            cylinder(d=M3_hole, h=20, center=true);
          }
        }
      }
    }
    
  }

}

module drive_wheel_round(){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;

  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));

//  radius = (chain_l/2)/sin(180/tow)+track_h/2-track_wall;
  radius = (chain_l/2)/sin(180/tow)+track_h/2-track_wall;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_d = 20;
  hub_h = wheel_w+5;
  hub_hole = 3.5;
  hub_hole_2 = 10;
  hub_hole_3 = 5.5;
  servo_hub_h = 4;
  servo_hub_h2 = 3;
  
  translate([0, 0, wheel_w/2]){
    difference(){
      edge1=7;
      edge2=4;
      wx1=0;
      wy1=wheel_w/2;
      wx2=radius-edge1;
      wy2=wheel_w/2;
      wx3=radius;
      wy3=wheel_w/2-edge2;
      wx4=wx3;
      wy4=-wy3;
      wx5=wx2;
      wy5=-wy2;
      wx6=0;
      wy6=-wy1;
      rotate_extrude($fn=200){
        polygon(points=[[wx1,wy1],[wx2,wy2],[wx3,wy3],[wx4,wy4],[wx5,wy5],[wx6,wy6]]);
      }

      //cylinder($fn=tow, r=radius, h=wheel_w, center=true);
      x1=0;
      y1=horn_w1/2;
      x2=horn_d/2-horn_w2/2;
      y2=horn_w2/2;
      x3=horn_d/2-horn_w2/2;
      y3=-horn_w2/2;
      x4=0;
      y4=-horn_w1/2;
      
      translate([0, 0, wheel_w/2-horn_thickness/2+0.1]){
        cylinder(d=15, h=horn_thickness, center=true);
      }
      for(i=[0:90:360]){
        rotate([0, 0, i]){
          translate([horn_mount, 0, 0]){
            cylinder(d=3, h=wheel_w*1.1, center=true);
          }
          translate([(horn_d-horn_w2)/2, 0, wheel_w/2-horn_thickness/2+0.1]){
            cylinder(d=horn_w2, h=horn_thickness, center=true);
          }
          translate([0, 0, wheel_w/2-horn_thickness+0.1]){
            linear_extrude(height=horn_thickness){
              polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
            }
          }
        }
      }
      cylinder(d=hub_hole, h=hub_h*1.5, center=true);
      cylinder(d=hub_hole_2, h=hub_h, center=true);
    }
  }
}

module rear_wheel_mount(){
  mount_h = 16;
  mount_h2 = 7;
  mount_h3 = 4;
  mount_d = 30;
  mount_d2=18;
  axis_d = 4.5;
  M4_nut_d = 8;
  M4_nut_h = 5;
  
  translate([0, 0, mount_h/2]){
    difference(){
      cylinder(d=mount_d, h=mount_h, center=true, $fn=6);
      cylinder(d=axis_d, h=mount_h*1.1, center=true);
      translate([0, 0, (mount_h-M4_nut_h)/2+0.1]){
        cylinder($fn=6, d=M4_nut_d, h=M4_nut_h, center=true);
      }
    }
  }
  translate([0, mount_d, mount_h3/2]){
    difference(){
      cylinder(d=15, h=mount_h3, center=true, $fn=6);
//      translate([0, 0, 1])
      cylinder(d=4, h=mount_h3+0.1, center=true);
    }
  }
  translate([mount_d+5, 0, mount_h2/2]){
    difference(){
      cylinder(d=mount_d, h=mount_h2, center=true);
      cylinder(d=axis_d, h=mount_h*1.1, center=true);
      translate([0, 0, 2])
      cylinder($fn=6, d=M4_nut_d, h=mount_h2, center=true);
      translate([0, mount_d/2, 0]){
        cube(size=[mount_d, mount_d-mount_d2, mount_h2*1.1], center=true);
      }
      translate([0, -mount_d/2, 0]){
        cube(size=[mount_d, mount_d-mount_d2, mount_h2*1.1], center=true);
      }
    }
  }
}

module rear_wheel(){
  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));

//  radius = (chain_l/2)/sin(180/tow)+track_h/2-track_wall;
  radius = (chain_l/2)/sin(180/tow)+track_h/2-track_wall;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_hole = 4.4;
  
  translate([0, 0, wheel_w/2]){
    difference(){
      edge1=7;
      edge2=4;
      wx1=0;
      wy1=wheel_w/2;
      wx2=radius-edge1;
      wy2=wheel_w/2;
      wx3=radius;
      wy3=wheel_w/2-edge2;
      wx4=wx3;
      wy4=-wy3;
      wx5=wx2;
      wy5=-wy2;
      wx6=0;
      wy6=-wy1;
      rotate_extrude($fn=200){
        polygon(points=[[wx1,wy1],[wx2,wy2],[wx3,wy3],[wx4,wy4],[wx5,wy5],[wx6,wy6]]);
      }
      //cylinder($fn=200, r=radius, h=wheel_w, center=true);
      cylinder(d=hub_hole, h=wheel_w*1.5, center=true);
    }
  }
}


module cable_chain(brim = 0){
  width=track_w;
  height=track_h;
  length=track_l;
  wall=track_wall;
  tolerance=0.6;
  tolerance_w=track_tolerance_w;
  tolerance_stop = 0.4;
  overlap=10;
  link_w=10;
  l_stop=length/2-(link_w/2-(length/2-height))-tolerance_stop;
  
  
  l=length-height;
  
  scale_a = height/(cos(180/8)*height);
//  scale_a = 1;
  
  x1=l/2;
  y1=0;
  x2=l/2;
  y2=height/2;
  x3=l_stop;
  y3=height/2;
  x4=l_stop;
  y4=height/3;
  
  brim_h = 0.2;
  brim_d = 10;
  
  // Brim
  if(brim == 1){
    for(i=[0:1:1]){
      mirror([0, i, 0]){
        translate([track_l/3.5+3, (track_w-track_wall)/2, brim_h/2]){
          cylinder(d=brim_d, h=brim_h, center=true);
        }
        translate([-track_l/2.7, track_w/2+track_wall*0.7, brim_h/2]){
          cylinder(d=brim_d, h=brim_h, center=true);
        }
      }
    }
  }
  
  for(i=[0:1:1])
  mirror([0, i, 0])
  translate([0, 0, track_h/2])
  difference(){
    union(){
      //Center bottom plate
      translate([0, 0, -track_h/2])
      linear_extrude(height=wall, scale=[0.7, 1]){
        square(size=[link_w, width-2*wall], center=true);
      }
      
      // Fromt side plate
      difference(){
        hull(){
          translate([0, track_w/2+wall/2+tolerance_w, 0])
          cube(size=[overlap, wall, height], center=true);
          translate([-l/2, track_w/2+wall/2+tolerance_w, 0])
          rotate([90, 0, 0])
          scale([1, scale_a]){
            rotate([0, 0, 360/8/2]){
              cylinder($fn=8, d=height, h=wall, center=true);
            }
          }
        }
        // Cut center cylinder
        translate([l/2, 0, 0])
        rotate([90, 0, 0])
        cylinder(d=track_h*1.2, h=track_w*2, center=true);

      }
      
      // Back side plate
      hull(){    
        translate([l/2, track_w/2-wall/2, 0])
        rotate([90, 0, 0])
        scale([1, scale_a]){
          rotate([0, 0, 360/8/2]){
            cylinder($fn=8, d=height, h=wall, center=true);
          }
        }
        translate([0, track_w/2-wall/2, 0])
        cube(size=[overlap, wall, height], center=true);
      }
      // hinge cone
      translate([l/2, track_w/2+wall/2, 0])
      rotate([90, 0, 0]){
        cylinder(d1=height/2-wall, d2=height/2, h=wall, center=true);
      }
      
      // Overlap link
      difference(){
        translate([0, track_w/2, 0])
        cube(size=[overlap, wall, height], center=true);
        // Cut center cylinder
        translate([l/2, 0, 0])
        rotate([90, 0, 0])
        cylinder(d=track_h*1.2, h=track_w*2, center=true);
      }

    }
    
    // Cut hinge cone
    translate([-l/2, track_w/2+wall/2+tolerance_w, 0]){
      rotate([90, 0, 0])
      cylinder(d1=height/2-wall, d2=height/2, h=wall+0.25, center=true);
    }
    // Cut center cylinder
    translate([-l/2, 0, 0])
    rotate([90, 0, 0])
    cylinder(d=track_h*1.2, h=track_w+tolerance_w*2, center=true);
    
    // Cut link holes
    translate([0, 6, -track_h/2])
    cylinder(d=M3_hole, h=track_h, center=true);
    translate([0, -6, -track_h/2])
    cylinder(d=M3_hole, h=track_h, center=true);
    
  }



//  }
  
}


module servo(tolerance=0, mount_holes=1, nut_shift = -29.0){
  mh_dis1 = 48;
  mh_dis2 = 10;
  
  translate([0, 0, servo_h/2]){
    cube(size=[servo_l+tolerance, servo_w+tolerance, servo_h+tolerance], center=true);
    translate([servo_l/2-servo_axis_offset, 0, 25]){
      rotate([0, 0, 90]){
        cylinder(d=30, h=2, center=true);
      }
    }
  }
  translate([0, 0, servo_h1+1]){
    cube(size=[servo_lt, servo_w+tolerance, 3], center=true);
  }
  if(mount_holes == 1){
    translate([-servo_l/2, 0, servo_h/2]){
      scale([1.5,1,1])
      cylinder(d=5, h=servo_h, center=true);
    }
    translate([mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=40, center=true);
      translate([0, 0, nut_shift])
      rotate([0, 0, 30])
      cylinder(d=M3_nut_e, h=40, center=true, $fn=6);
    }
    translate([-mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=40, center=true);
      translate([0, 0, nut_shift])
      rotate([0, 0, 30])
      cylinder(d=M3_nut_e, h=40, center=true, $fn=6);
    }
    translate([-mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=40, center=true);
      translate([0, 0, nut_shift])
      rotate([0, 0, 30])
      cylinder(d=M3_nut_e, h=40, center=true, $fn=6);
    }
    translate([mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=40, center=true);
      translate([0, 0, nut_shift])
      rotate([0, 0, 30])
      cylinder(d=M3_nut_e, h=40, center=true, $fn=6);
    }
  }

  
}



module chassis(){
//  rotate([90, 0, 270])servo();
  
  // Brim
  brim_h = 0.35;
  brim_d = 20;
  translate([chassis_w/2, chassis_l/2, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  translate([-chassis_w/2, chassis_l/2, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  translate([-chassis_w/2, -chassis_l/2, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  translate([chassis_w/2, -chassis_l/2, brim_h/2])
  cylinder(d=brim_d, h=brim_h, center=true);
  
  difference(){
    translate([0, 0, chassis_h/2]){
      cube(size=[chassis_w, chassis_l, chassis_h], center=true);
    }
    
    // Center cut
    translate([0, 0, chassis_h/2+chassis_wall]){
      a = chassis_w - 2 * chassis_wall;
      b = chassis_l - 2 * chassis_wall;
      cube(size=[a, b, chassis_h], center=true);
    }
    
    // Front motor cuts
    for(i=[0:1:1]){
      mirror([i, 0, 0]){
        a = 20-chassis_w/2;
        b = front_axis_x-servo_axis_offset;
        translate([a, b, front_axis_y]){
          rotate([90, 0, 270]){
            servo(1);
          }
        }
      }
    }

    //Rear axis cuts
    //diff=(track_l-track_h)/2;
    diff=15;
    translate([0, rear_axis_x-diff/2, rear_axis_y]){
      rotate([90, 0, 90]){
        cylinder(d=rear_axle_d, h=chassis_w*1.1, center=true);
      }
    }
    translate([0, rear_axis_x+diff/2, rear_axis_y]){
      rotate([90, 0, 90]){
        cylinder(d=rear_axle_d, h=chassis_w*1.1, center=true);
      }
    }
    translate([0, rear_axis_x, rear_axis_y]){
      cube(size=[chassis_w*1.1, diff, rear_axle_d], center=true);
    }

    //Cabel holes
    translate([0, 75, 0]){
      cylinder(d=22, h=15, center=true);
    }
    hull(){
      translate([0, 5, 0]){
        cylinder(d=22, h=15, center=true);
      }
      translate([0, -5, 0]){
        cylinder(d=22, h=15, center=true);
      }
    }
    translate([0, -75, 0]){
      cylinder(d=22, h=15, center=true);
    }
    
    //mount holes grid bottom
    for(j=[-ch_no_y/2:1:ch_no_y/2]){
      for(i=[-ch_no_x/2:1:ch_no_x/2]){
        a=ch_dis_x * i;
        b=ch_dis_y * j;
        translate([a, b, 2.26]){
          cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
          translate([0, 0, chassis_wall/2-2.26+.75])
          cylinder(d=M3_nut_e, h=chassis_wall, center=true, $fn=6);
        }
      }
    }

    //mount holes grid left and right
    edge_z = (ch_no_y2)/2 * ch_dis_y;
    for(i=[-ch_no_y/2:1:ch_no_y/2]){
      translate([0, ch_dis_y * i, chassis_h/2-edge_z])
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=chassis_w*1.1, center=true);
        rotate([0, 0, 30])
        cylinder(d=M3_nut_e, h=chassis_w-2.95, center=true, $fn=6);
      }
      translate([0, ch_dis_y * i, chassis_h/2 + edge_z])
      rotate([0, 90, 0]){
        if(i<2 || i>6){
          cylinder(d=M3_hole, h=chassis_w*1.1, center=true);
          rotate([0, 0, 30])
          cylinder(d=M3_nut_e, h=chassis_w-2.95, center=true, $fn=6);
        }
      }
    }
      
    
    //mount holes grid front and rear
    translate([0, 0, chassis_h/2])
    rotate([90, 0, 0]){
      for(j=[-ch_no_y2/2:1:ch_no_y2/2]){
        for(i=[-ch_no_x2/2:1:ch_no_x2/2])
        translate([ch_dis_x * i, ch_dis_y * j, 0]){
          cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
          cylinder(d=M3_nut_e, h=chassis_l-2.95, center=true, $fn=6);
        }
      }
    }

  }
   
  if(Assembled == 0){
    //bridge_post(10, width=6, brim_w=15, brim_l=6, link=0);
    for(i=[0:1:1]){
      mirror([i, 0, 0]){
        translate([-59.0, 50, 0]){
          rotate([0, 0, 90]){
            bridge_post(37.95, 10, 17, 15, 0);
          }
        }
        translate([-59, 33, 0]){
          rotate([0, 0, 90]){
            bridge_post(37.95, 10, 17, 15, 0);
          }
        }
        translate([-58, 43, 15]){
          cube(size=[7, 20, 1], center=true);
        }
      }
    }
  }
}



module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}

module bridge_post(height, width=6, brim_w=10, brim_l=6, link=0){
  edge=6;
  tip=edge;
  tip_w = 0.2;
  brim_h = 0.3;
  socket_h = chassis_wall*2;
  
  x1=edge/2;
  y1=0;
  x2=edge/2;
  y2=height-tip;
  x3=-width;
  y3=height-tip;
  x4=-edge/2;
  y4=socket_h;
  x5=-edge/2;
  y5=0;
  
  translate([edge/2, 0, brim_h/2]){
    cube(size=[brim_w, brim_l, brim_h], center=true);
  }
  
  rotate([90, 0, 90]){
    linear_extrude(height=edge){
      polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4],[x5,y5]]);
    }
  }
  
  if(link>0){
    translate([link/2, 0, height/2]){
      cube(size=[link, edge/2, 2], center=true);
    }
  }
  
  x1t=edge/2;
  y1t=0;
  x2t=0;
  y2t=edge;
  x3t=-edge/2;
  y3t=0;
  
  translate([edge/2, edge/2, height-tip]){
    rotate([90, 0, 0]){
      linear_extrude(height=edge/2+width){
        polygon(points=[[x1t,y1t],[x2t,y2t],[x3t,y3t]]);
      }
    }    
  }

  translate([edge/2, -(width-edge/2)/2, height-tip/2]){
    cube(size=[tip_w, width+edge/2, tip], center=true);    
  }

}
